﻿using System;
using System.Configuration;
using System.Xml;
using System.Web.UI.WebControls;
using System.Web;

namespace Memory_Giving_API_Examples
{
    public partial class getGiftAidDeclaration : System.Web.UI.Page
    {
        protected const string operation = "getGiftAidDeclaration";

        protected string Data
        {
            get
            {
                return  "api_key="  + HttpUtility.UrlEncode(txt_api_key.Text);
            }
        }

        protected string SOAPData
        {
            get
            {
                return "<api_key>"  + txt_api_key.Text + "</api_key>";
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text    = ConfigurationManager.AppSettings["APIKey"].ToString();
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                litGiftAidDeclaration.Text  = responseNode["Data"].InnerText;
                
                ResultPanel.Visible         = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }
    }
}