﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class loadTributeGroupByPageName : System.Web.UI.Page
    {
        protected const string operation = "loadTributeGroupByPageName";

        protected string Data
        {
            get
            {
                return                                              "api_key="                  + HttpUtility.UrlEncode(txt_api_key.Text) +
                        (txt_tribute_group_page_name.Text  != "" ?  "&tribute_group_page_name=" + HttpUtility.UrlEncode(txt_tribute_group_page_name.Text)  : "");
            }
        }

        protected string SOAPData
        {
            get
            {
                return                                              "<api_key>"                 + txt_api_key.Text                  + "</api_key>" +
                        (txt_tribute_group_page_name.Text  != "" ?  "<tribute_group_page_name>" + txt_tribute_group_page_name.Text  + "</tribute_group_page_name>" : "");
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text = ConfigurationManager.AppSettings["APIKey"].ToString();

            if (!IsPostBack)
            {
                string query_string_page_name = Request.QueryString["tribute_group_page_name"];
                if (!string.IsNullOrEmpty(query_string_page_name) && !string.IsNullOrWhiteSpace(query_string_page_name))
                {
                    txt_tribute_group_page_name.Text = query_string_page_name;
                    DoPost(sender, e);
                }
            }
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute("loadTributeGroupByPageName", Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                id.Text                     = responseNode["Data"]["id"].InnerText;
                page_name.Text              = responseNode["Data"]["page_name"].InnerText;

                ResultsRepeater.DataSource  = responseNode["Data"]["tributes"].ChildNodes;
                ResultsRepeater.DataBind();
                
                ResultPanel.Visible         = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }

        protected void BindResults(Object sender, RepeaterItemEventArgs e)
        {
            XmlNode xmlNode                     = (XmlNode)e.Item.DataItem;

            Literal id                          = (Literal)e.Item.FindControl("id");
            Literal page_name                   = (Literal)e.Item.FindControl("page_name");

            Literal aliases                     = (Literal)e.Item.FindControl("aliases");
            Literal name                        = (Literal)e.Item.FindControl("name");
            Literal age                         = (Literal)e.Item.FindControl("age");
            Literal age_unit                    = (Literal)e.Item.FindControl("age_unit");
            Literal DoDMessage                  = (Literal)e.Item.FindControl("DoDMessage");
            Image cropped_photo_path            = (Image)e.Item.FindControl("cropped_photo_path");
            Image cropped_photo_thumb_path      = (Image)e.Item.FindControl("cropped_photo_thumb_path");
            Literal colour                      = (Literal)e.Item.FindControl("colour");
            Literal date_of_death               = (Literal)e.Item.FindControl("date_of_death");
            Literal facebook_link               = (Literal)e.Item.FindControl("facebook_link");
            Literal message                     = (Literal)e.Item.FindControl("message");
            Literal date_created                = (Literal)e.Item.FindControl("date_created");
            Literal date_closed                 = (Literal)e.Item.FindControl("date_closed");
            Literal donations_total             = (Literal)e.Item.FindControl("donations_total");
            Literal donations_online_total      = (Literal)e.Item.FindControl("donations_online_total");
            Literal donations_offline_total     = (Literal)e.Item.FindControl("donations_offline_total");
            Literal gift_aid_total              = (Literal)e.Item.FindControl("gift_aid_total");
            
            Literal service_published               = (Literal)e.Item.FindControl("service_published");
            Literal service_title                   = (Literal)e.Item.FindControl("service_title");
            Literal service_date_time               = (Literal)e.Item.FindControl("service_date_time");
            Literal service_address_prefix          = (Literal)e.Item.FindControl("service_address_prefix");
            Literal service_address                 = (Literal)e.Item.FindControl("service_address");
            Literal service_location                = (Literal)e.Item.FindControl("service_location");
            Literal service_notes                   = (Literal)e.Item.FindControl("service_notes");
            Literal service_webcast                 = (Literal)e.Item.FindControl("service_webcast");
            Literal service_webcast_url             = (Literal)e.Item.FindControl("service_webcast_url");
            Literal service_webcast_username        = (Literal)e.Item.FindControl("service_webcast_username");
            Literal service_webcast_password        = (Literal)e.Item.FindControl("service_webcast_password");
            Literal service_order_of_service_pdf    = (Literal)e.Item.FindControl("service_order_of_service_pdf");
            Literal service_order_of_service_url    = (Literal)e.Item.FindControl("service_order_of_service_url");
            
            Literal committal_published             = (Literal)e.Item.FindControl("committal_published");
            Literal committal_title                 = (Literal)e.Item.FindControl("committal_title");
            Literal committal_date_time             = (Literal)e.Item.FindControl("committal_date_time");
            Literal committal_address_prefix        = (Literal)e.Item.FindControl("committal_address_prefix");
            Literal committal_address               = (Literal)e.Item.FindControl("committal_address");
            Literal committal_location              = (Literal)e.Item.FindControl("committal_location");
            Literal committal_notes                 = (Literal)e.Item.FindControl("committal_notes");
            Literal committal_webcast               = (Literal)e.Item.FindControl("committal_webcast");
            Literal committal_webcast_url           = (Literal)e.Item.FindControl("committal_webcast_url");
            Literal committal_webcast_username      = (Literal)e.Item.FindControl("committal_webcast_username");
            Literal committal_webcast_password      = (Literal)e.Item.FindControl("committal_webcast_password");
            
            Literal reception_published             = (Literal)e.Item.FindControl("reception_published");
            Literal reception_title                 = (Literal)e.Item.FindControl("reception_title");
            Literal reception_date_time             = (Literal)e.Item.FindControl("reception_date_time");
            Literal reception_address_prefix        = (Literal)e.Item.FindControl("reception_address_prefix");
            Literal reception_address               = (Literal)e.Item.FindControl("reception_address");
            Literal reception_location              = (Literal)e.Item.FindControl("reception_location");
            Literal reception_notes                 = (Literal)e.Item.FindControl("reception_notes");
            Literal reception_webcast               = (Literal)e.Item.FindControl("reception_webcast");
            Literal reception_webcast_url           = (Literal)e.Item.FindControl("reception_webcast_url");
            Literal reception_webcast_username      = (Literal)e.Item.FindControl("reception_webcast_username");
            Literal reception_webcast_password      = (Literal)e.Item.FindControl("reception_webcast_password");
            
            Literal fd_id                       = (Literal)e.Item.FindControl("fd_id");                          
            Literal fd_company_name             = (Literal)e.Item.FindControl("fd_company_name");                
            Literal fd_address1                 = (Literal)e.Item.FindControl("fd_address1");                    
            Literal fd_address2                 = (Literal)e.Item.FindControl("fd_address2");                    
            Literal fd_town                     = (Literal)e.Item.FindControl("fd_town");                        
            Literal fd_postcode                 = (Literal)e.Item.FindControl("fd_postcode");                    
            Literal fd_description              = (Literal)e.Item.FindControl("fd_description");                 
            Literal fd_web                      = (Literal)e.Item.FindControl("fd_web");                         
            Literal fd_contact_first_name       = (Literal)e.Item.FindControl("fd_contact_first_name");
            Literal fd_contact_last_name        = (Literal)e.Item.FindControl("fd_contact_last_name");
            Literal fd_contact_email            = (Literal)e.Item.FindControl("fd_contact_email");
            Literal fd_telephone_1_label        = (Literal)e.Item.FindControl("fd_telephone_1_label");
            Literal fd_telephone_1              = (Literal)e.Item.FindControl("fd_telephone_1");
            Literal fd_telephone_2_label        = (Literal)e.Item.FindControl("fd_telephone_2_label");
            Literal fd_telephone_2              = (Literal)e.Item.FindControl("fd_telephone_2");
            Image fd_cropped_logo_path          = (Image)e.Item.FindControl("fd_cropped_logo_path");       
            Literal fd_trade_body               = (Literal)e.Item.FindControl("fd_trade_body");                  
            
            
            Literal charity_id                  = (Literal)e.Item.FindControl("charity_id");                     
            Literal charity_charity_name        = (Literal)e.Item.FindControl("charity_charity_name");           
            Literal charity_aliases             = (Literal)e.Item.FindControl("charity_aliases");                
            Literal charity_charity_number      = (Literal)e.Item.FindControl("charity_charity_number");         
            Literal charity_description         = (Literal)e.Item.FindControl("charity_description");            
            Literal charity_web                 = (Literal)e.Item.FindControl("charity_web");                    
            Image charity_cropped_logo_path     = (Image)e.Item.FindControl("charity_cropped_logo_path");

            Repeater SubResultsRepeater = (Repeater)e.Item.FindControl("SubResultsRepeater");

            id.Text                             = xmlNode["id"].InnerText;
            page_name.Text                      = xmlNode["page_name"].InnerText;
            aliases.Text                        = xmlNode["aliases"].InnerText;
            name.Text                           = xmlNode["name"].InnerText;
            age.Text                            = xmlNode["age"].InnerText;
            if (!xmlNode["age"].IsEmpty)
            {
                age.Text                        = xmlNode["age"].InnerText;
            }
            else
            {
                age.Text                        = "";
            }
            if (!xmlNode["age_unit"].IsEmpty)
            {
                age_unit.Text                   = xmlNode["age_unit"].InnerText;
            }
            else
            {
                age_unit.Text                   = "";
            }
            DoDMessage.Text                     = xmlNode["DoDMessage"].InnerText;
            cropped_photo_path.ImageUrl         = "http://" + xmlNode["cropped_photo_path"].InnerText;
            cropped_photo_thumb_path.ImageUrl   = "http://" + xmlNode["cropped_photo_thumb_path"].InnerText;
            colour.Text                         = xmlNode["colour"].InnerText;
            date_of_death.Text                  = xmlNode["date_of_death"].InnerText;
            facebook_link.Text                  = xmlNode["facebook_link"].InnerText;
            message.Text                        = xmlNode["message"].InnerText;
            date_created.Text                   = xmlNode["date_created"].InnerText;
            if (xmlNode["date_closed"] != null)
            {
                date_closed.Text = xmlNode["date_closed"].InnerText;
            }            
            donations_total.Text                = xmlNode["donations_total"].InnerText;
            donations_online_total.Text         = xmlNode["donations_online_total"].InnerText;
            donations_offline_total.Text        = xmlNode["donations_offline_total"].InnerText;
            gift_aid_total.Text                 = xmlNode["gift_aid_total"].InnerText;

            #region Event Fields that are being phased out
            service_published.Text              = xmlNode["service_display"].InnerText;
            service_date_time.Text              = xmlNode["service_date_time"].InnerText;
            service_address_prefix.Text         = xmlNode["service_chapel"].InnerText;
            service_address.Text                = xmlNode["service_address"].InnerText;
            service_location.Text               = xmlNode["service_location"].InnerText;
            service_notes.Text                  = xmlNode["service_notes"].InnerText;

            committal_published.Text            = xmlNode["committal_display"].InnerText;
            committal_address.Text              = xmlNode["committal_address"].InnerText;
            committal_location.Text             = xmlNode["committal_location"].InnerText;

            reception_published.Text            = xmlNode["reception_display"].InnerText;
            reception_date_time.Text            = xmlNode["reception_date_time"].InnerText;
            reception_address.Text              = xmlNode["reception_address"].InnerText;
            reception_location.Text             = xmlNode["reception_location"].InnerText;
            #endregion

            #region New Event Fields - Not available on the live site.
            if (xmlNode["events"] != null)
            { 
                foreach (XmlNode xmlSubNode in xmlNode["events"].ChildNodes)
                {
                    string type                                 = xmlSubNode["type"].InnerText;
                    string published                            = xmlSubNode["published"].InnerText;
                    string title                                = xmlSubNode["title"].InnerText;
                    string date_time                            = xmlSubNode["date_time"].InnerText;
                    string address_prefix                       = xmlSubNode["address_prefix"].InnerText;
                    string address                              = xmlSubNode["address"].InnerText;
                    string location                             = xmlSubNode["location"].InnerText;
                    string notes                                = xmlSubNode["notes"].InnerText;
                    string webcast                              = xmlSubNode["webcast"].InnerText;
                    string webcast_url                          = xmlSubNode["webcast_url"].InnerText;
                    string webcast_username                     = xmlSubNode["webcast_username"].InnerText;
                    string webcast_password                     = xmlSubNode["webcast_password"].InnerText;
                    string order_of_service_pdf                 = xmlSubNode["order_of_service_pdf"].InnerText;
                    string order_of_service_url                 = xmlSubNode["order_of_service_url"].InnerText;

                    switch (type)
                    {
                        case "Service":
                            service_published.Text                      = published;
                            service_title.Text                          = title;
                            service_date_time.Text                      = date_time;
                            service_address_prefix.Text                 = address_prefix;
                            service_address.Text                        = address;
                            service_location.Text                       = location;
                            service_notes.Text                          = notes;
                            service_webcast.Text                        = webcast;
                            service_webcast_url.Text                    = webcast_url;
                            service_webcast_username.Text               = webcast_username;
                            service_webcast_password.Text               = webcast_password;
                            service_order_of_service_pdf.Text           = order_of_service_pdf;
                            service_order_of_service_url.Text           = order_of_service_url;
                            break;
                        case "Committal":
                            committal_published.Text                    = published;
                            committal_title.Text                        = title;
                            committal_date_time.Text                    = date_time;
                            committal_address_prefix.Text               = address_prefix;
                            committal_address.Text                      = address;
                            committal_location.Text                     = location;
                            committal_notes.Text                        = notes;
                            committal_webcast.Text                      = webcast;
                            committal_webcast_url.Text                  = webcast_url;
                            committal_webcast_username.Text             = webcast_username;
                            committal_webcast_password.Text             = webcast_password;
                            break;
                        case "Reception":
                            reception_published.Text                    = published;
                            reception_title.Text                        = title;
                            reception_date_time.Text                    = date_time;
                            reception_address_prefix.Text               = address_prefix;
                            reception_address.Text                      = address;
                            reception_location.Text                     = location;
                            reception_notes.Text                        = notes;
                            reception_webcast.Text                      = webcast;
                            reception_webcast_url.Text                  = webcast_url;
                            reception_webcast_username.Text             = webcast_username;
                            reception_webcast_password.Text             = webcast_password;
                            break;
                    }
                }
            }
            #endregion

            fd_id.Text                          = xmlNode["funeral_director"]["id"].InnerText;
            fd_company_name.Text                = xmlNode["funeral_director"]["company_name"].InnerText;
            fd_address1.Text                    = xmlNode["funeral_director"]["address1"].InnerText;
            fd_address2.Text                    = xmlNode["funeral_director"]["address2"].InnerText;
            fd_town.Text                        = xmlNode["funeral_director"]["town"].InnerText;
            fd_postcode.Text                    = xmlNode["funeral_director"]["postcode"].InnerText;
            fd_description.Text                 = xmlNode["funeral_director"]["description"].InnerText;
            fd_web.Text                         = xmlNode["funeral_director"]["web"].InnerText;
            fd_contact_first_name.Text          = xmlNode["funeral_director"]["contact_first_name"].InnerText;
            fd_contact_last_name.Text           = xmlNode["funeral_director"]["contact_last_name"].InnerText;
            fd_contact_email.Text               = xmlNode["funeral_director"]["contact_email"].InnerText;
            fd_telephone_1_label.Text           = xmlNode["funeral_director"]["telephone_1_label"].InnerText;
            fd_telephone_1.Text                 = xmlNode["funeral_director"]["telephone_1"].InnerText;
            fd_telephone_2_label.Text           = xmlNode["funeral_director"]["telephone_2_label"].InnerText;
            fd_telephone_2.Text                 = xmlNode["funeral_director"]["telephone_2"].InnerText;
            fd_cropped_logo_path.ImageUrl       = "http://" + xmlNode["funeral_director"]["cropped_logo_path"].InnerText;
            fd_trade_body.Text                  = xmlNode["funeral_director"]["trade_body"].InnerText;


            charity_id.Text                     = xmlNode["charity"]["id"].InnerText;
            charity_charity_name.Text           = xmlNode["charity"]["charity_name"].InnerText;
            charity_aliases.Text                = xmlNode["charity"]["aliases"].InnerText;
            charity_charity_number.Text         = xmlNode["charity"]["charity_number"].InnerText;
            charity_description.Text            = xmlNode["charity"]["description"].InnerText;
            charity_web.Text                    = xmlNode["charity"]["web"].InnerText;
            charity_cropped_logo_path.ImageUrl  = "http://" + xmlNode["charity"]["cropped_logo_path"].InnerText;
            
            
            if (xmlNode["donations"] != null)
            {
                SubResultsRepeater.DataSource = xmlNode["donations"].ChildNodes;
                SubResultsRepeater.DataBind();
            }
        }

        protected void BindSubResults(Object sender, RepeaterItemEventArgs e)
        {
            XmlNode xmlNode                     = (XmlNode)e.Item.DataItem;

            Literal id                          = (Literal)e.Item.FindControl("id");
            Literal tribute_id                  = (Literal)e.Item.FindControl("tribute_id");
            Literal anonymous                   = (Literal)e.Item.FindControl("anonymous");
            Literal display_name                = (Literal)e.Item.FindControl("display_name");
            Literal message                     = (Literal)e.Item.FindControl("message");
            Literal donation                    = (Literal)e.Item.FindControl("donation");
            Literal hide_donation_value         = (Literal)e.Item.FindControl("hide_donation_value");
            Literal donation_online             = (Literal)e.Item.FindControl("donation_online");
            Literal gift_aid                    = (Literal)e.Item.FindControl("gift_aid");
            Literal date_donation               = (Literal)e.Item.FindControl("date_donation");
            Literal value_gift_aid              = (Literal)e.Item.FindControl("value_gift_aid");
            
            id.Text                             = xmlNode["id"].InnerText;
            tribute_id.Text                     = xmlNode["tribute_id"].InnerText;
            anonymous.Text                      = xmlNode["anonymous"].InnerText;
            display_name.Text                   = xmlNode["display_name"].InnerText;
            message.Text                        = xmlNode["message"].InnerText;
            donation.Text                       = xmlNode["donation"].InnerText;
            donation_online.Text                = xmlNode["donation_online"].InnerText;
            gift_aid.Text                       = xmlNode["gift_aid"].InnerText;
            date_donation.Text                  = xmlNode["date_donation"].InnerText;
            value_gift_aid.Text                 = xmlNode["value_gift_aid"].InnerText;

            bool hide_donation_val              = Convert.ToBoolean(xmlNode["hide_donation_value"].InnerText);
            hide_donation_value.Text            = hide_donation_val.ToString();

            if (hide_donation_val)
            {
                donation.Text                   += "(Donor has chosen to hide donation value)";
                value_gift_aid.Text             += "(Donor has chosen to hide donation value)";
            }

        }
    }
}