﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class removeDonation : System.Web.UI.Page
    {
        protected const string operation = "removeDonation";

        protected string Data
        {
            get
            {
                return                                      "api_key="                  + HttpUtility.UrlEncode(txt_api_key.Text)                   +
                    (txt_user_id.Text               != "" ? "&user_id="                 + HttpUtility.UrlEncode(txt_user_id.Text)                   : "") +
                    (txt_donation_id.Text           != "" ? "&donation_id="             + HttpUtility.UrlEncode(txt_donation_id.Text)               : "");
            }
        }

        protected string SOAPData
        {
            get
            {
                return                                      "<api_key>"                 + txt_api_key.Text                  + "</api_key>"                  +
                    (txt_user_id.Text               != "" ? "<user_id>"                 + txt_user_id.Text                  + "</user_id>"                  : "") +
                    (txt_donation_id.Text            != "" ? "<donation_id>"            + txt_donation_id.Text              + "</donation_id>"               : "");
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text                        = ConfigurationManager.AppSettings["APIKey"].ToString();
            txt_user_id.Text                        = ConfigurationManager.AppSettings["UserID"].ToString();
            txt_donation_id.Text                    = "";
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                //Response.Redirect(responseNode["Data"].InnerText);
                id.Text                             = responseNode["Data"]["id"].InnerText;
                tribute_id.Text                     = responseNode["Data"]["tribute_id"].InnerText;
                anonymous.Text                      = responseNode["Data"]["anonymous"].InnerText;
                display_name.Text                   = responseNode["Data"]["display_name"].InnerText;
                message.Text                        = responseNode["Data"]["message"].InnerText;
                donation.Text                       = responseNode["Data"]["donation"].InnerText;
                donation_online.Text                = responseNode["Data"]["donation_online"].InnerText;
                gift_aid.Text                       = responseNode["Data"]["gift_aid"].InnerText;
                date_donation.Text                  = responseNode["Data"]["date_donation"].InnerText;
                value_gift_aid.Text                 = responseNode["Data"]["value_gift_aid"].InnerText;
                
                if (responseNode["Data"]["PaymentGatewayURL"] != null)
                {
                    string PaymentGatewayURL            = responseNode["Data"]["PaymentGatewayURL"].InnerText;
                    hpl_PaymentGatewayURL.Text          =
                    hpl_PaymentGatewayURL.NavigateUrl   = PaymentGatewayURL;
                    hpl_PaymentGatewayURL.Enabled       = true;
                }
                else
                {
                    hpl_PaymentGatewayURL.Text          = "NA";
                    hpl_PaymentGatewayURL.NavigateUrl   = "";
                    hpl_PaymentGatewayURL.Enabled       = false;
                }
                bool hide_donation_val              = Convert.ToBoolean(responseNode["Data"]["hide_donation_value"].InnerText);
                hide_donation_value.Text            = hide_donation_val.ToString();

                if (hide_donation_val)
                {
                    donation.Text                   += "(Donor has chosen to hide donation value)";
                    value_gift_aid.Text             += "(Donor has chosen to hide donation value)";
                }

                ResultPanel.Visible                 = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }
    }
}