﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;
using System.Net;
using System.IO;

namespace Memory_Giving_API_Examples
{
    public partial class search : System.Web.UI.Page
    {
        protected const string operation = "search";
        
        protected string Data
        {
            get
            {
                return                                      "api_key="              + HttpUtility.UrlEncode(txt_api_key.Text)           +
                        (txt_deceased_name.Text     != "" ? "&deceased_name="       + HttpUtility.UrlEncode(txt_deceased_name.Text)     : "") +
                        (txt_funeral_director.Text  != "" ? "&funeral_director="    + HttpUtility.UrlEncode(txt_funeral_director.Text)  : "") +
                        (txt_charity.Text           != "" ? "&charity="             + HttpUtility.UrlEncode(txt_charity.Text)           : "") +
                                                            "&show_open="           + chk_show_open.Checked                             +
                                                            "&show_closed="         + chk_show_closed.Checked                           +
                                                            "&scope_narrow="        + chk_scope_narrow.Checked                          +
                                                            "&date_limit="          + HttpUtility.UrlEncode(txt_date_limit.Text);
            }
        }
        
        protected string SOAPData
        {
            get
            {
                return                                      "<api_key>"             + txt_api_key.Text                              + "</api_key>"                  +
                        (txt_deceased_name.Text     != "" ? "<deceased_name>"       + txt_deceased_name.Text                        + "</deceased_name>"    : "")   +
                        (txt_funeral_director.Text  != "" ? "<funeral_director>"    + txt_funeral_director.Text                     + "</funeral_director>" : "")   +
                        (txt_charity.Text           != "" ? "<charity>"             + txt_charity.Text                              + "</charity>"          : "")   +
                                                            "<show_open>"           + chk_show_open.Checked                         + "</show_open>"                +
                                                            "<show_closed>"         + chk_show_closed.Checked                       + "</show_closed>"              +
                                                            "<scope_narrow>"        + chk_scope_narrow.Checked                      + "</scope_narrow>"             +
                                                            "<date_limit>"          + HttpUtility.UrlEncode(txt_date_limit.Text)    + "</date_limit>";
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text        = ConfigurationManager.AppSettings["APIKey"].ToString();
            chk_show_open.Checked   = true;
            txt_date_limit.Text     = DateTime.Now.AddMonths(-1).ToString("dd MMMM yyyy");
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                search_results.DataSource   = responseNode.GetElementsByTagName("anyType");
                search_results.DataBind();

                ResultPanel.Visible         = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }

        protected void BindSearchResults(Object sender, RepeaterItemEventArgs e)
        {
            XmlNode xmlNode                         = (XmlNode)e.Item.DataItem;

            Image       image                       = (Image)e.Item.FindControl("image");
            Literal     name                        = (Literal)e.Item.FindControl("name");
            Literal     fd_name                     = (Literal)e.Item.FindControl("fd_name");
            Literal     charity_name                = (Literal)e.Item.FindControl("charity_name");
            Literal     service_date_time           = (Literal)e.Item.FindControl("service_date_time");
            Literal     DoDMessage                  = (Literal)e.Item.FindControl("DoDMessage");

            HyperLink   live_page                   = (HyperLink)e.Item.FindControl("live_page");
            HyperLink   loadTributeByID             = (HyperLink)e.Item.FindControl("loadTributeByID");
            HyperLink   loadTributeGroupByID        = (HyperLink)e.Item.FindControl("loadTributeGroupByID");
            HyperLink   loadTributeByPageName       = (HyperLink)e.Item.FindControl("loadTributeByPageName");
            HyperLink   loadTributeGroupByPageName  = (HyperLink)e.Item.FindControl("loadTributeGroupByPageName");

            image.ImageUrl                      = "http://" + xmlNode["cropped_photo_path"].InnerText;
            name.Text                           = xmlNode["name"].InnerText;
            fd_name.Text                        = xmlNode["funeral_director"].InnerText;
            charity_name.Text                   = xmlNode["charity"].InnerText;

            service_date_time.Text              = xmlNode["service_date_time"].InnerText;
            DoDMessage.Text                     = xmlNode["DoDMessage"].InnerText;

            live_page.NavigateUrl               = ConfigurationManager.AppSettings["Host"].ToString() + xmlNode["page_name"].InnerText;
            live_page.Text                      = live_page.NavigateUrl; 

            if (xmlNode["tribute_group_id"].InnerText == "-1")
            {
                loadTributeByID.NavigateUrl         = "~/loadTributeByID.aspx?id=" + xmlNode["id"].InnerText;
                loadTributeByID.Text                = loadTributeByID.NavigateUrl;
                loadTributeByPageName.NavigateUrl   = "~/loadTributeByPageName.aspx?page_name=" + xmlNode["page_name"].InnerText;
                loadTributeByPageName.Text          = loadTributeByPageName.NavigateUrl;

                loadTributeGroupByID.Text           =
                loadTributeGroupByPageName.Text     = "n/a";
            }
            else
            {
                loadTributeByID.Text                = 
                loadTributeByPageName.Text          = "n/a";

                loadTributeGroupByID.NavigateUrl    = "~/loadTributeGroupByID.aspx?id=" + xmlNode["tribute_group_id"].InnerText;
                loadTributeGroupByID.Text           = loadTributeGroupByID.NavigateUrl;

                loadTributeGroupByPageName.NavigateUrl  = "~/loadTributeGroupByPageName.aspx?tribute_group_page_name=" + xmlNode["page_name"].InnerText;
                loadTributeGroupByPageName.Text         = loadTributeGroupByPageName.NavigateUrl;
            }
        }
    }
}